// D import file generated from 'derelict/util/exception.d'
module derelict.util.exception;
class DerelictException : Exception
{
	public this(string msg)
	{
		super(msg);
	}
}
private struct FailedSharedLib
{
	string name;
	string reason;
}
class SharedLibLoadException : DerelictException
{
	private string _sharedLibName;
	public 
	{
		static void throwNew(string[] libNames, string[] reasons);
		this(string msg)
		{
			super(msg);
			_sharedLibName = "";
		}
		this(string msg, string sharedLibName)
		{
			super(msg);
			_sharedLibName = sharedLibName;
		}
		string sharedLibName();
	}
}
class SymbolLoadException : DerelictException
{
	private string _symbolName;
	public 
	{
		this(string msg)
		{
			super(msg);
		}
		this(string sharedLibName, string symbolName)
		{
			super("Failed to load symbol " ~ symbolName ~ " from shared library " ~ sharedLibName);
			_symbolName = symbolName;
		}
		string symbolName();
	}
}
enum ShouldThrow 
{
	No,
	Yes,
}
alias MissingSymbolCallbackFunc = ShouldThrow function(string symbolName);
alias MissingSymbolCallbackDg = ShouldThrow delegate(string symbolName);
alias MissingSymbolCallback = MissingSymbolCallbackDg;
