// D import file generated from 'derelict/util/loader.d'
module derelict.util.loader;
private 
{
	import std.array : split;
	import std.string : strip;
	import derelict.util.sharedlib;
	import derelict.util.exception;
}
struct SharedLibVersion
{
	int major;
	int minor;
	int patch;
}
abstract class SharedLibLoader
{
	private 
	{
		string _libNames;
		SharedLib _lib;
	}
	public this(string libNames)
	{
		_libNames = libNames;
	}
	public final 
	{
		void load();
		void load(SharedLibVersion minRequiredVersion);
		void load(string libNames);
		void load(string libNames, SharedLibVersion minRequiredVersion);
		void load(string[] libNames);
		void load(string[] libNames, SharedLibVersion minRequiredVersion);
		void unload();
		@property 
		{
			bool isLoaded();
			void missingSymbolCallback(MissingSymbolCallbackDg callback);
			void missingSymbolCallback(MissingSymbolCallbackFunc callback);
			MissingSymbolCallback missingSymbolCallback();
		}
	}
	protected 
	{
		abstract void loadSymbols();
		void configureMinimumVersion(SharedLibVersion minVersion);
		void* loadSymbol(string name, bool doThrow = true);
		final @property ref SharedLib lib();
		final void bindFunc(void** ptr, string funcName, bool doThrow = true);
	}
}
